Package org.apache.storm.redis.bolt

## Class AbstractRedisBolt

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichBolt
    - - org.apache.storm.topology.base.BaseTickTupleAwareRichBolt
      - - org.apache.storm.redis.bolt.AbstractRedisBolt

- All Implemented Interfaces:
    `Serializable`, `IBolt`, `IComponent`, `IRichBolt`
  Direct Known Subclasses:
    `RedisFilterBolt`, `RedisLookupBolt`, `RedisStoreBolt`

      public abstract class AbstractRedisBolt
      extends BaseTickTupleAwareRichBolt

  AbstractRedisBolt class is for users to implement custom bolts which makes interaction with Redis.

  Due to environment abstraction, AbstractRedisBolt provides JedisCommands which contains only single key operations.

  Custom Bolts may want to follow this pattern:

  >      JedisCommands jedisCommands = null;
  >      try {
  >          jedisCommand = getInstance();
  >          // do some works
  >      } finally {
  >          if (jedisCommand != null) {
  >              returnInstance(jedisCommand);
  >          }
  >      }

  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected OutputCollector` | `collector` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractRedisBolt​(JedisClusterConfig config)` | Constructor for Redis Cluster environment (JedisCluster).
    `AbstractRedisBolt​(JedisPoolConfig config)` | Constructor for single Redis environment (JedisPool).

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `cleanup()` | Called when an IBolt is going to be shutdown.
    `protected JedisCommandsContainer` | `getInstance()` | Borrow JedisCommands instance from container.
    `void` | `prepare​(Map<String,​Object> map, TopologyContext topologyContext, OutputCollector collector)` | Called when a task for this component is initialized within a worker on the cluster.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseTickTupleAwareRichBolt

      `execute, onTickTuple, process`

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `declareOutputFields, getComponentConfiguration`

- - ### Field Detail

    - #### collector

          protected OutputCollector collector

  - ### Constructor Detail

    - #### AbstractRedisBolt

          public AbstractRedisBolt​(JedisPoolConfig config)

      Constructor for single Redis environment (JedisPool).
      Parameters:
        `config` - configuration for initializing JedisPool

    - #### AbstractRedisBolt

          public AbstractRedisBolt​(JedisClusterConfig config)

      Constructor for Redis Cluster environment (JedisCluster).
      Parameters:
        `config` - configuration for initializing JedisCluster

  - ### Method Detail

    - #### prepare

          public void prepare​(Map<String,​Object> map,
                              TopologyContext topologyContext,
                              OutputCollector collector)

      Called when a task for this component is initialized within a worker on the cluster. It provides the bolt with the environment in which the bolt executes.

      This includes the:

      Parameters:
        `map` - The Storm configuration for this bolt. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `topologyContext` - This object can be used to get information about this task's place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this bolt. Tuples can be emitted at any time, including the prepare and cleanup methods. The collector is thread-safe and should be saved as an instance variable of this bolt object.

    - #### getInstance

          protected JedisCommandsContainer getInstance()

      Borrow JedisCommands instance from container.

      JedisCommands is an interface which contains single key operations.
      Returns:
        implementation of JedisCommands
      See Also:
        `JedisCommandsContainer`

    - #### cleanup

          public void cleanup()

      Description copied from interface: `IBolt`
      Called when an IBolt is going to be shutdown. Storm will make a best-effort attempt to call this if the worker shutdown is orderly. The `Config.SUPERVISOR_WORKER_SHUTDOWN_SLEEP_SECS` setting controls how long orderly shutdown is allowed to take. There is no guarantee that cleanup will be called if shutdown is not orderly, or if the shutdown exceeds the time limit.

      The one context where cleanup is guaranteed to be called is when a topology is killed when running Storm in local mode.

      Specified by:
        `cleanup` in interface `IBolt`
      Overrides:
        `cleanup` in class `BaseRichBolt`